"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// var { List } = require("immutable");
var ChainWebSocket = require("./ChainWebSocket");
var GrapheneApi = require("./GrapheneApi");
var ChainConfig = require("./ChainConfig");

var ApisInstance = function () {
	function ApisInstance() {
		_classCallCheck(this, ApisInstance);

		this._db = null;
		this._net = null;
		this._hist = null;
		this._crypt = null;
		this._secure = null;
	}

	/** @arg {string} connection .. */


	_createClass(ApisInstance, [{
		key: "connect",
		value: function connect(cs) {
			var rpc_user = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";

			var _this = this;

			var rpc_password = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
			var autoReconnect = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;


			// console.log("INFO\tApiInstances\tconnect\t", cs);

			if (typeof window !== "undefined" && window.location && window.location.protocol === "https:" && cs.indexOf("wss://") < 0) {
				throw new Error("Secure domains require wss connection");
			}

			this.ws_rpc = new ChainWebSocket(cs, this.statusCb, autoReconnect);

			this.init_promise = this.ws_rpc.login(rpc_user, rpc_password).then(function () {
				_this.ws_rpc.on_reconnect = function () {
					return _this.ws_rpc.login(rpc_user, rpc_password);
				};
				return Promise.resolve().then(function () {
					return _this.db_api().exec("get_chain_id", []).then(function (_chain_id) {
						_this.chain_id = _chain_id;
						ChainConfig.setChainId(_chain_id);
						return _this;
					});
				});
			});
		}
	}, {
		key: "close",
		value: function close() {
			if (this.ws_rpc) this.ws_rpc.close();
			this.ws_rpc = null;
		}
	}, {
		key: "db_api",
		value: function db_api() {
			if (!this._db) {
				this._db = new GrapheneApi(this.ws_rpc, "database");
			}
			return this._db;
		}
	}, {
		key: "network_api",
		value: function network_api() {
			if (!this._net) {
				this._net = new GrapheneApi(this.ws_rpc, "network_broadcast");
			}
			return this._net;
		}
	}, {
		key: "history_api",
		value: function history_api() {
			if (!this._hist) {
				this._hist = new GrapheneApi(this.ws_rpc, "history");
			}
			return this._hist;
		}
	}, {
		key: "crypto_api",
		value: function crypto_api() {
			if (!this._crypt) {
				this._crypt = new GrapheneApi(this.ws_rpc, "crypto");
			}
			return this._crypt;
		}
	}, {
		key: "secure_api",
		value: function secure_api() {
			if (!this._secure) {
				this._secure = new GrapheneApi(this.ws_rpc, "secure");
			}
			return this._secure;
		}
	}, {
		key: "setRpcConnectionStatusCallback",
		value: function setRpcConnectionStatusCallback(callback) {
			this.statusCb = callback;
		}
	}]);

	return ApisInstance;
}();

module.exports = ApisInstance;